﻿using System;


using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;

namespace WindowsFormsApplication3
{
    class ExpIndicatorsCF : IUIElementCreationFilter
    {
        private const int ExpansionIndicatorSize = 15;
        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is PreRowAreaUIElement)
            {
                
                //Get the ExpansionIndicatorUIElement
                Infragistics.Win.UltraWinGrid.ExpansionIndicatorUIElement aExpansionIndicatorUIElement;
                aExpansionIndicatorUIElement = (Infragistics.Win.UltraWinGrid.ExpansionIndicatorUIElement)parent.GetDescendant(typeof(Infragistics.Win.UltraWinGrid.ExpansionIndicatorUIElement));

                //If it isn't there, exit
                if (aExpansionIndicatorUIElement == null)
                    return;

                //Determine how much to shift the ExpansionIndicator up and 
                //to the left so it matches up with the lines. 
                int Shift = (ExpansionIndicatorSize - aExpansionIndicatorUIElement.Rect.Width) / 2;

                //Figure out the new X and Y coords. 
                int NewX, NewY;
                NewX = aExpansionIndicatorUIElement.Rect.X - Shift;
                if (NewX < 2)
                NewX = 2;

                NewY = aExpansionIndicatorUIElement.Rect.Y - Shift;
                ImageUIElement image = new ImageUIElement(aExpansionIndicatorUIElement, Image.FromFile("..//..//circle.png"));

                //aExpansionIndicatorUIElement.ChildElements.Add(image);
                

                aExpansionIndicatorUIElement.Rect = new Rectangle(NewX, NewY, ExpansionIndicatorSize, ExpansionIndicatorSize);
                image.Rect = aExpansionIndicatorUIElement.Rect;

                Console.WriteLine("X: " + NewX + ", Y: " + NewY + ", Width & Height: " + ExpansionIndicatorSize);
                
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
